local MicroMenuButtons = {
	CharacterMicroButton, 
	SpellbookMicroButton, 
	TalentMicroButton, 
	AchievementMicroButton, 
	QuestLogMicroButton,
	SocialsMicroButton, 
	PVPMicroButton, 
	LFDMicroButton, 
	MainMenuMicroButton, 
	HelpMicroButton
}

function MiniMainBar:InitMicroMenu()
	for i = 1, #MicroMenuButtons do
		local Button = MicroMenuButtons[i]
		Button:SetParent(MiniMainBar_MicroMenu)
	end
	
	self:SecureHook("UpdateMicroButtons")
	
	MiniMainBar:HideMicroMenu(self.db.profile.MicroMenuHidden)
	MiniMainBar:LockMicroMenu(self.db.profile.MicroMenuLocked)
	MiniMainBar:ScaleMicroMenu(self.db.profile.MicroMenuScale)
end

function MiniMainBar:UpdateMicroMenu()
	if UnitHasVehicleUI("player") then return end 
	
	local b = CharacterMicroButton
	b:ClearAllPoints()
	b:SetPoint("BOTTOMLEFT", MiniMainBar_MicroMenu, "BOTTOMLEFT", 2, 3)
	
	MiniMainBar:HideMicroMenu(self.db.profile.MicroMenuHidden)
	
	if not self.db.profile.MicroMenuHidden then
		MiniMainBar:LockMicroMenu(self.db.profile.MicroMenuLocked)
		MiniMainBar:ScaleMicroMenu(self.db.profile.MicroMenuScale)
	
		MiniMainBar_MicroMenu:ClearAllPoints()
		MiniMainBar_MicroMenu:SetPoint(
			MiniMainBar.db.profile.MicroMenuPoint.Point, 
			WorldFrame, 
			self.db.profile.MicroMenuPoint.RelativePoint, 
			self.db.profile.MicroMenuPoint.XOffset, 
			self.db.profile.MicroMenuPoint.YOffset
		)
	end
end

function MiniMainBar:UpdateMicroButtons()

end

function MiniMainBar:HideMicroMenu(value)
	if value then	
		MiniMainBar_MicroMenu:Hide()
	else
		MiniMainBar_MicroMenu:Show()
	end
end

function MiniMainBar:LockMicroMenu(value)
	if value then
		MiniMainBar_MicroMenu:EnableMouse(false)
		MiniMainBar_MicroMenu:SetMovable(false)
		MiniMainBar_MicroMenu:RegisterForDrag(nil)
		MiniMainBar_MicroMenu:SetBackdrop({ })
	else
		MiniMainBar_MicroMenu:EnableMouse(true)
		MiniMainBar_MicroMenu:SetMovable(true)
		MiniMainBar_MicroMenu:RegisterForDrag("RightButton")
		MiniMainBar_MicroMenu:SetBackdrop({ 
			bgFile = "Interface/DialogFrame/UI-DialogBox-Background" 
		})
	end
end

function MiniMainBar:ScaleMicroMenu(Scale)
	MiniMainBar_MicroMenu:SetScale(Scale)
end

function MiniMainBar_MicroMenu_OnDragStart()
	if MiniMainBar.db.profile.MicroMenuLocked then return end
	
	this:StartMoving();
	this.isMoving = true;
end

function MiniMainBar_MicroMenu_OnDragStop()
	MiniMainBar_MicroMenu:StopMovingOrSizing();
	MiniMainBar_MicroMenu.isMoving = false;
	
	Point, RelativeTo, RelativePoint, XOffset, YOffset = MiniMainBar_MicroMenu:GetPoint()
	
	MiniMainBar.db.profile.MicroMenuPoint.XOffset = XOffset
	MiniMainBar.db.profile.MicroMenuPoint.YOffset = YOffset
	MiniMainBar.db.profile.MicroMenuPoint.Point = Point						
	MiniMainBar.db.profile.MicroMenuPoint.RelativePoint = RelativePoint
end
