local MiniMainBar = LibStub("AceAddon-3.0"):GetAddon("MiniMainBar")
local options = nil

function MiniMainBar:InitOptions()
	self.OptionsFrames = {}

	-- setup options table
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("MiniMainBar", self:ConstructOptions())
	self.OptionsFrames = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("MiniMainBar", "MiniMainBar")

	--MiniMainBar:RegisterModuleOptions("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(MiniMainBar.db), "Profiles")

	--LibStub("AceConsole-3.0"):RegisterChatCommand("minimainbar", "OpenOptions")
	--LibStub("AceConsole-3.0"):RegisterChatCommand("mmb", "OpenOptions")
end

function MiniMainBar:ConstructOptions()
	if not options then
		options = {
			name = "MiniMainBar",
			type = "group",
			args = {
				general = {
					order = 1,
					name = "MiniMainBar Settings",
					type = "group",
					args = {
						bags = {
							order = 1,
							name = "Bag Bar Options",
							type = "group",
							args = {
								bags_hide = {
									order = 1,
									name = "Hide",
									desc = "Hides or unhides the bags bar.",
									type = "toggle",
									get = function () return self.db.profile.BagsBarHidden end,
									set = function (info, value)  
									          self.db.profile.BagsBarHidden = value
											  self:UpdateGUI()
										  end
								},
								bags_lock = {
									order = 2,
									name = "Lock",
									desc = "Locks or unlocks the bags bar.",
									type = "toggle",
									get = function () return self.db.profile.BagsBarLocked end,
									set = function (info, value)  
									          self.db.profile.BagsBarLocked = value
											  self:UpdateGUI()
										  end
								},
								bags_scale = {
									order = 3,
									name = "Scale",
									desc = "Scales the bags bar.",
									type = "range",
									min = 0.1,
									max = 2.0,
									step = 0.05,
									get = function () return self.db.profile.BagsBarScale end,
									set = function (info, value)
										      self.db.profile.BagsBarScale = value
											  self:UpdateGUI()
										  end
								}
							}
						},
						micromenu = {
							order = 2,
							name = "Micromenu Bar Options",
							type = "group",
							args = {
								micromenu_hide = {
									order = 1,
									name = "Hide",
									desc = "Hides or unhides the micromenu bar.",
									type = "toggle",
									get = function () return self.db.profile.MicroMenuHidden end,
									set = function (info, value)  
									          self.db.profile.MicroMenuHidden = value
											  self:UpdateGUI()
										  end
								},
								micromenu_lock = {
									order = 2,
									name = "Lock",
									desc = "Locks or unlocks the micromenu bar.",
									type = "toggle",
									get = function () return self.db.profile.MicroMenuLocked end,
									set = function (info, value)  
									          self.db.profile.MicroMenuLocked = value
											  self:UpdateGUI()
										  end
								},
								micromenu_scale = {
									order = 3,
									name = "Scale",
									desc = "Scales the micromenu.",
									type = "range",
									min = 0.1,
									max = 2.0,
									step = 0.05,
									get = function () return self.db.profile.MicroMenuScale end,
									set = function (info, value)
										      self.db.profile.MicroMenuScale = value
											  self:UpdateGUI()
										  end
								}
							}
						},
						pet = {
							order = 3,
							name = "Pet Bar Options",
							type = "group",
							args = {
								pet_hide = {
									order = 1,
									name = "Hide",
									desc = "Hides or unhides the pet bar.",
									type = "toggle",
									get = function () return self.db.profile.PetBarHidden end,
									set = function (info, value)  
									          self.db.profile.PetBarHidden = value
											  self:UpdateGUI()
										  end
								},
								pet_lock = {
									order = 2,
									name = "Lock",
									desc = "Locks or unlocks the pet bar.",
									type = "toggle",
									get = function () return self.db.profile.PetBarLocked end,
									set = function (info, value)  
									          self.db.profile.PetBarLocked = value
											  self:UpdateGUI()
										  end
								},
								pet_scale = {
									order = 3,
									name = "Scale",
									desc = "Scales the pet bar.",
									type = "range",
									min = 0.1,
									max = 2.0,
									step = 0.05,
									get = function () return self.db.profile.PetBarScale end,
									set = function (info, value)
										      self.db.profile.PetBarScale = value
											  self:UpdateGUI()
										  end
								}
							}
						},
						stance = {
							order = 4,
							name = "Stance Bar Options",
							type = "group",
							args = {
								stance_hide = {
									order = 1,
									name = "Hide",
									desc = "Hides or unhides the stance bar.",
									type = "toggle",
									get = function () return self.db.profile.StanceBarHidden end,
									set = function (info, value)  
									          self.db.profile.StanceBarHidden = value
											  self:UpdateGUI()
										  end
								},
								stance_lock = {
									order = 2,
									name = "Lock",
									desc = "Locks or unlocks the stance bar.",
									type = "toggle",
									get = function () return self.db.profile.StanceBarLocked end,
									set = function (info, value)  
									          self.db.profile.StanceBarLocked = value
											  self:UpdateGUI()
										  end
								},
								stance_scale = {
									order = 3,
									name = "Scale",
									desc = "Scales the stance.",
									type = "range",
									min = 0.1,
									max = 2.0,
									step = 0.05,
									get = function () return self.db.profile.StanceBarScale end,
									set = function (info, value)
										      self.db.profile.StanceBarScale = value
											  self:UpdateGUI()
										  end
								}
							}
						}
					}
				}
			}
		}
	end
	
	return options
end

function MiniMainBar:OpenOptions() 
	-- open the profiles tab before, so the menu expands
	--InterfaceOptionsFrame_OpenToCategory(MiniMainBar.optionsFrames.Profiles)
	InterfaceOptionsFrame_OpenToCategory(self.OptionsFrames)
end